/* Lexical analyzer and Parser generators error codes */
#define LEXERR_NO_ERROR						0
#include "resource.h"

/* Error message */
#define MAX_ERROR_MESSAGE					255		// Maximum length of error message
#define MAX_ERROR_PARAM						64		// Maximum length of parameter for error message, trailing zero excluded
#define MAX_FILE_NAME						128		// Maximum length of file name, trailing zero excluded
#define MAX_ERROR_SYMBOL					80		// Maximum length of terminal label to display

WORD LexErrorCode;									// The error code

unsigned char LexErrorStringParam[MAX_ERROR_PARAM+1];		// String Parameter for error message
WORD LexErrorIntParam;								// Integer Parameter for error message
unsigned char LexErrorCharParam;					// Character Parameter for error message

WORD PErrorState;									// Index of state on which conflict happened
WORD PErrorTerminal;								// Value of terminal on which conflict happened
WORD PAction1;										// SHIFT or REDUCE
WORD PAction2;										// SHIFT or REDUCE
WORD PNumber1;										// If PAction1 = SHIFT, then index of state to go to, else production
													// to reduce by.
WORD PNumber2;										// If PAction2 = SHIFT, then index of state to go to, else production
													// to reduce by.

DWORD LexErrorLine;									// Line in source code where error was detected
DWORD LexErrorColumn;								// Column in source code where error was detected
DWORD LexErrorLineComment;							// Line begining of a comment where error was detected
DWORD LexErrorLineString;							// Line begining of a string where error was detected
DWORD LexErrorColComment;							// Column begining of a comment where error was detected
DWORD LexErrorColString;							// Column begining of a string where error was detected
unsigned char LexTraceFile[MAX_FILE_NAME + 1];		// Name of trace file
BOOL LexTrace;										// If TRUE, produce trace file
