// extcompi.cpp : implementation file
//

#include "stdafx.h"
#include "phoenix.h"
#include "extcompi.h"
#include "ph_start.h"
#include "packdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExtCompile dialog


CExtCompile::CExtCompile(CWnd* pParent /*=NULL*/)
    : CFileDialog(TRUE,"par",NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_ENABLETEMPLATE|OFN_FILEMUSTEXIST,
                  "Lexical Files (*.lex) |*.lex| Parser Files (*.par) |*.par||",pParent)
{
    //{{AFX_DATA_INIT(CExtCompile)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}

void CExtCompile::DoDataExchange(CDataExchange* pDX)
{
    CFileDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CExtCompile)
        // NOTE: the ClassWizard will add DDX and DDV calls here
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExtCompile, CFileDialog)
    //{{AFX_MSG_MAP(CExtCompile)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CExtCompile message handlers

void CExtCompile::OnOK()
{
    CFileDialog::OnOK();
    if(GetPathName().GetLength() == 0) return;

    CWnd *pWnd = AfxGetApp() -> m_pMainWnd; // Get main window
    HWND hWnd = pWnd -> m_hWnd; // Get main window's handle

    int nTarget = (((CButton *)GetDlgItem(IDC_R_UNIX))->GetCheck() == 1 ? TARGET_UNIX : TARGET_WIN31);

    // Load the Phoenix DLL
    HINSTANCE hPhoenixDll = LoadLibrary("PHX.DLL");
    if(hPhoenixDll < HINSTANCE_ERROR)
    {
        MessageBeep((UINT)-1);
        MessageBox("Failed to load PHX.DLL");
    }

    CString FileName = GetPathName();
    char Path[128];
    LPSTR lpF;
    lstrcpy((LPSTR)Path,(LPCSTR)FileName);
    BOOL fIsLexFile = FALSE;
    int lenPath = lstrlen((LPSTR)Path);
    if(Path[lenPath - 1] == 'x' || Path[lenPath - 1] == 'X')
        fIsLexFile = TRUE;  // Source file is a .LEX file
    lpF = (LPSTR)Path + lenPath;
    while(*lpF != '\\') lpF --;
    *lpF ='\0'; // Strip out the file name, keep the path
    HCURSOR hCur = SetCursor(LoadCursor(NULL,IDC_WAIT));

    if(fIsLexFile)
    {
        // Compile lex file
        BOOL result = PhoenixAnalyzeLexFile(hWnd,(LPSTR)(LPCSTR)FileName,(LPSTR)Path,nTarget,
            NO_LINE_DIRECTIVES,TRUE,DEFAULT_PF);
        SetCursor(hCur);
    
        MessageBeep((UINT)-1);
    
        if(result == FALSE)
            MessageBox("Failed to generate lexical analyzer !");
        else
            MessageBox("Lexical analyzer produced !");
    }
    else
    {
        // Compile parser file
        BOOL result = PhoenixAnalyzeParserFile(hWnd,(LPSTR)(LPCSTR)FileName,(LPSTR)Path,nTarget,
            NO_LINE_DIRECTIVES,TRUE);
        SetCursor(hCur);
    
        MessageBeep((UINT)-1);
    
        if(result == FALSE)
            MessageBox("Failed to generate parser !");
        else
            MessageBox("Parser produced !");
    }

    FreeLibrary(hPhoenixDll);
}

BOOL CExtCompile::OnInitDialog()
{
    CFileDialog::OnInitDialog();

    ((CButton *)GetDlgItem(IDC_R_UNIX))->SetCheck(1);

    return TRUE;  // return TRUE  unless you set the focus to a control
}
