// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "phoenix.h"

#include "mdichfrm.h"
#include "mainfrm.h"
#include "extcompi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
    ON_COMMAND(ID_COMPILE_EXTERNALFILE, OnCompileExternalFile)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
    // same order as in the bitmap 'toolbar.bmp'
    ID_FILE_NEW,
    ID_FILE_OPEN,
    ID_FILE_SAVE,
        ID_SEPARATOR,
    ID_EDIT_CUT,
    ID_EDIT_COPY,
    ID_EDIT_PASTE,
        ID_SEPARATOR,
    ID_COMPILE_GEN,
        ID_SEPARATOR,
    ID_FILE_PRINT,
    ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
    ID_SEPARATOR,           // status line indicator
    ID_INDICATOR_CAPS,
    ID_INDICATOR_NUM,
    ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    // TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

// Get the MDI Client Window's handle
CWnd *CMainFrame::GetMDIClient()
{
    CWnd *pWnd = GetWindow(GW_CHILD);
    while(pWnd != NULL)
    {
        char ClassName[10];

        GetClassName(pWnd -> GetSafeHwnd(),ClassName,sizeof(ClassName));
        if(!lstrcmp(ClassName,"MDIClient")) break;
        pWnd = pWnd -> GetWindow(GW_HWNDNEXT);
    }

    return pWnd;
}

// Set the color of all views
void CMainFrame::UpdateTextColor()
{
    CWnd *pWnd = GetMDIClient() -> GetWindow(GW_CHILD); // Get the first MDI Child
    while(pWnd != NULL) // Loop on MDI child windows
    {
        if(pWnd -> IsIconic() == FALSE)
        {
            if(pWnd -> GetWindow(GW_OWNER) == NULL) // Skip Icon title window
            {
                // Got a valid MDI child window
                CView *pActiveView = (CView *)((CMDIChFrm *)pWnd) -> GetActiveView();
                if(pActiveView != NULL)
                    pActiveView -> Invalidate();

                // Invalidate all views of the document, which are necessarily in the same MDI child window
                pActiveView -> GetDocument() -> UpdateAllViews(pActiveView);
            }
        }
        pWnd = pWnd -> GetNextWindow();
    }
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    if (!m_wndToolBar.Create(this) ||
        !m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
        !m_wndToolBar.SetButtons(buttons,
          sizeof(buttons)/sizeof(UINT)))
    {
        TRACE("Failed to create toolbar\n");
        return -1;      // fail to create
    }

    if (!m_wndStatusBar.Create(this) ||
        !m_wndStatusBar.SetIndicators(indicators,
          sizeof(indicators)/sizeof(UINT)))
    {
        TRACE("Failed to create status bar\n");
        return -1;      // fail to create
    }

    return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnCompileExternalFile()
{
    CExtCompile dlg;
    dlg.m_ofn.lpTemplateName = MAKEINTRESOURCE(IDD_EXTCOMPILE);
    dlg.m_ofn.hInstance = AfxGetInstanceHandle();
    dlg.m_ofn.lpstrFile = "";
    dlg.DoModal();
}
