/**************************************************************
*                                                             *
* Using the PHOENIX.DLL lexical and LALR(1) parser generators *
* Caution: the generators are memory consuming                *
*                                                             *
**************************************************************/

/* Target system
   ************* */
#define TARGET_WIN31        1
#define TARGET_UNIX         2


/* Line directives generation
   ************************** */
#define NO_LINE_DIRECTIVES  0
#define LINE_DIRECTIVES     1


/* Packed arrays
   ************* */
#define UNPACKED_ARRAYS     0
#define PACKED_ARRAYS       1


/* Call to lexical analyzer generator
   ********************************** */


extern "C"
{
BOOL FAR PASCAL PhoenixAnalyzeParserFile(
    HWND    hwnd,           // Handle of parent window
    LPSTR   ParserFile,     // Input parser source file
    LPSTR   TargetDir,      // Target directory
    int     TargetPlatform, // Target platform: TARGET_WIN31 or TARGET_UNIX
    BOOL    LineDirectives, // Generate #line directives ?
    BOOL    Pack            // Pack Action and Goto tables ?
    );

BOOL FAR PASCAL PhoenixAnalyzeLexFile(
    HWND    hwnd,           // Handle of parent window
    LPSTR   LexFile,        // Input lex source file
    LPSTR   TargetDir,      // Target directory
    int     TargetPlatform, // Target platform: TARGET_WIN31 or TARGET_UNIX,
    BOOL    LineDirectives, // Generate #line directives ?
    BOOL    Pack,           // Pack final DFA ?
    WORD    PPercent        // Percentage of matching gotos in two states, over which decision is taken to
                            // merge the states
    );
}
